VTK: vtkSurfaceLICInterface Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkSurfaceLICInterface Class Reference

public API for surface lic parameters arbitrary geometry. More...

`#include <vtkSurfaceLICInterface.h>`

Inheritance diagram for vtkSurfaceLICInterface:
[legend]
Collaboration diagram for vtkSurfaceLICInterface:
[legend]

## Public Types
typedef vtkObject | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
| Return 1 if this class is the same type of (or a subclass of) the named class. More...
vtkSurfaceLICInterface * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | WriteTimerLog (const char *)
| Methods used for parallel benchmarks. More...
void | ShallowCopy (vtkSurfaceLICInterface *m)
| Make a shallow copy of this interface. More...
virtual void | ReleaseGraphicsResources (vtkWindow *win)
| Release any graphics resources that are being consumed by this mapper. More...
bool | CanRenderSurfaceLIC (vtkActor *actor)
| Returns true when rendering LIC is possible. More...
void | ValidateContext (vtkRenderer *renderer)
| Look for changes that would trigger stage updates. More...
virtual vtkPainterCommunicator * | CreateCommunicator (int)
| Creates a new communicator with/without the calling processes as indicated by the passed in flag, if not 0 the calling process is included in the new communicator. More...
void | CreateCommunicator (vtkRenderer *, vtkActor *, vtkDataObject *data)
| Creates a new communicator for internal use based on this rank's visible data. More...
vtkPainterCommunicator * | GetCommunicator ()
void | UpdateCommunicator (vtkRenderer *renderer, vtkActor *actor, vtkDataObject *data)
| Called from a mapper, does what is needed to make sure the communicators are ready. More...
void | InitializeResources ()
| resoucre allocators More...
void | PrepareForGeometry ()
void | CompletedGeometry ()
void | GatherVectors ()
void | ApplyLIC ()
void | CombineColorsAndLIC ()
void | CopyToScreen ()
virtual void | GetGlobalMinMax (vtkPainterCommunicator *, float &, float &)
| Get the min/max across all ranks. More...
void | SetNumberOfSteps (int val)
| Get/Set the number of integration steps in each direction. More...
virtual int | GetNumberOfSteps ()
| Get/Set the number of integration steps in each direction. More...
void | SetStepSize (double val)
| Get/Set the step size (in pixels). More...
virtual double | GetStepSize ()
| Get/Set the step size (in pixels). More...
void | SetNormalizeVectors (int val)
| Normalize vectors during integration. More...
virtual void | NormalizeVectorsOn ()
| Normalize vectors during integration. More...
virtual void | NormalizeVectorsOff ()
| Normalize vectors during integration. More...
virtual int | GetNormalizeVectors ()
| Normalize vectors during integration. More...
void | SetMaskOnSurface (int val)
| When set MaskOnSurface computes |V| for use in the fragment masking tests on the surface. More...
virtual void | MaskOnSurfaceOn ()
| When set MaskOnSurface computes |V| for use in the fragment masking tests on the surface. More...
virtual void | MaskOnSurfaceOff ()
| When set MaskOnSurface computes |V| for use in the fragment masking tests on the surface. More...
virtual int | GetMaskOnSurface ()
| When set MaskOnSurface computes |V| for use in the fragment masking tests on the surface. More...
void | SetMaskThreshold (double val)
| The MaskThreshold controls the rendering of fragments in stagnant regions of flow. More...
virtual double | GetMaskThreshold ()
| The MaskThreshold controls the rendering of fragments in stagnant regions of flow. More...
void | SetMaskColor (double *val)
| The MaskColor is used on masked fragments. More...
void | SetMaskColor (double r, double g, double b)
| The MaskColor is used on masked fragments. More...
virtual double * | GetMaskColor ()
| The MaskColor is used on masked fragments. More...
virtual void | GetMaskColor (double &, double &, double &)
| The MaskColor is used on masked fragments. More...
virtual void | GetMaskColor (double[3])
| The MaskColor is used on masked fragments. More...
void | SetMaskIntensity (double val)
| The MaskIntensity controls the blending of the mask color and the geometry color. More...
virtual double | GetMaskIntensity ()
| The MaskIntensity controls the blending of the mask color and the geometry color. More...
void | SetEnhancedLIC (int val)
| EnhancedLIC mean compute the LIC twice with the second pass using the edge-enhanced result of the first pass as a noise texture. More...
virtual int | GetEnhancedLIC ()
| EnhancedLIC mean compute the LIC twice with the second pass using the edge-enhanced result of the first pass as a noise texture. More...
virtual void | EnhancedLICOn ()
| EnhancedLIC mean compute the LIC twice with the second pass using the edge-enhanced result of the first pass as a noise texture. More...
virtual void | EnhancedLICOff ()
| EnhancedLIC mean compute the LIC twice with the second pass using the edge-enhanced result of the first pass as a noise texture. More...
virtual double | GetLowLICContrastEnhancementFactor ()
| This feature is used to fine tune the contrast enhancement. More...
virtual double | GetHighLICContrastEnhancementFactor ()
| This feature is used to fine tune the contrast enhancement. More...
void | SetLowLICContrastEnhancementFactor (double val)
| This feature is used to fine tune the contrast enhancement. More...
void | SetHighLICContrastEnhancementFactor (double val)
| This feature is used to fine tune the contrast enhancement. More...
virtual double | GetLowColorContrastEnhancementFactor ()
| This feature is used to fine tune the contrast enhancement. More...
virtual double | GetHighColorContrastEnhancementFactor ()
| This feature is used to fine tune the contrast enhancement. More...
void | SetLowColorContrastEnhancementFactor (double val)
| This feature is used to fine tune the contrast enhancement. More...
void | SetHighColorContrastEnhancementFactor (double val)
| This feature is used to fine tune the contrast enhancement. More...
void | SetAntiAlias (int val)
| Enable/Disable the anti-aliasing pass. More...
virtual void | AntiAliasOn ()
| Enable/Disable the anti-aliasing pass. More...
virtual void | AntiAliasOff ()
| Enable/Disable the anti-aliasing pass. More...
virtual int | GetAntiAlias ()
| Enable/Disable the anti-aliasing pass. More...
void | SetLICIntensity (double val)
| Factor used when blend mode is set to COLOR_MODE_BLEND. More...
virtual double | GetLICIntensity ()
| Factor used when blend mode is set to COLOR_MODE_BLEND. More...
void | SetMapModeBias (double val)
| Factor used when blend mode is set to COLOR_MODE_MAP. More...
virtual double | GetMapModeBias ()
| Factor used when blend mode is set to COLOR_MODE_MAP. More...
void | SetNoiseDataSet (vtkImageData *data)
| Set the data containing a noise array as active scalars. More...
vtkImageData * | GetNoiseDataSet ()
| Set the data containing a noise array as active scalars. More...
void | SetGenerateNoiseTexture (int shouldGenerate)
| Set/Get the noise texture source. More...
virtual int | GetGenerateNoiseTexture ()
| Set/Get the noise texture source. More...
void | SetNoiseTextureSize (int length)
| Set/Get the side length in pixels of the noise texture. More...
virtual int | GetNoiseTextureSize ()
| Set/Get the side length in pixels of the noise texture. More...
void | SetNoiseGrainSize (int val)
| Each noise value will be length^2 pixels in area. More...
virtual int | GetNoiseGrainSize ()
| Each noise value will be length^2 pixels in area. More...
void | SetMinNoiseValue (double val)
| Set/Get the minimum and mximum gray scale values that the generated noise can take on. More...
void | SetMaxNoiseValue (double val)
| Set/Get the minimum and mximum gray scale values that the generated noise can take on. More...
virtual double | GetMinNoiseValue ()
| Set/Get the minimum and mximum gray scale values that the generated noise can take on. More...
virtual double | GetMaxNoiseValue ()
| Set/Get the minimum and mximum gray scale values that the generated noise can take on. More...
void | SetNumberOfNoiseLevels (int val)
| Set/Get the number of discrete values a noise pixel may take on. More...
virtual int | GetNumberOfNoiseLevels ()
| Set/Get the number of discrete values a noise pixel may take on. More...
void | SetImpulseNoiseProbability (double val)
| Control the density of the noise. More...
virtual double | GetImpulseNoiseProbability ()
| Control the density of the noise. More...
void | SetImpulseNoiseBackgroundValue (double val)
| The color to use for untouched pixels when impulse noise probability < 1. More...
virtual double | GetImpulseNoiseBackgroundValue ()
| The color to use for untouched pixels when impulse noise probability < 1. More...
void | SetNoiseGeneratorSeed (int val)
| Set/Get the seed value used by the random number generator. More...
virtual int | GetNoiseGeneratorSeed ()
| Set/Get the seed value used by the random number generator. More...
void | SetHasVectors (bool val)
| Does the data have vectors which we require. More...
bool | GetHasVectors ()
| Does the data have vectors which we require. More...
virtual void | SetEnable (int)
| Enable/Disable LIC. More...
virtual int | GetEnable ()
| Enable/Disable LIC. More...
virtual void | EnableOn ()
| Enable/Disable LIC. More...
virtual void | EnableOff ()
| Enable/Disable LIC. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual bool | UsesGarbageCollector () const
| Indicate whether the class uses `vtkGarbageCollector` or not. More...

## Static Public Member Functions
static vtkSurfaceLICInterface * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkSurfaceLICInterface * | SafeDownCast (vtkObjectBase *o)
static bool | IsSupported (vtkRenderWindow *context)
| Returns true if the rendering context supports extensions needed by this painter. More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
| vtkSurfaceLICInterface ()
| ~vtkSurfaceLICInterface () override
void | UpdateNoiseImage (vtkRenderWindow *renWin)
| Updates the noise texture, downsampling by the requested sample rate. More...
virtual bool | NeedToUpdateCommunicator ()
| Return false if stage can be skipped. More...
bool | NeedToRenderGeometry (vtkRenderer *renderer, vtkActor *actor)
| Return false if stage can be skipped. More...
bool | NeedToGatherVectors ()
| Return false if stage can be skipped. More...
bool | NeedToComputeLIC ()
| Return false if stage can be skipped. More...
bool | NeedToColorLIC ()
| Return false if stage can be skipped. More...
void | SetUpdateAll ()
| Return false if stage can be skipped. More...
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
virtual void | ReportReferences (vtkGarbageCollector *)
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
int | Enable
int | NumberOfSteps
double | StepSize
int | NormalizeVectors
int | EnhancedLIC
int | EnhanceContrast
double | LowLICContrastEnhancementFactor
double | HighLICContrastEnhancementFactor
double | LowColorContrastEnhancementFactor
double | HighColorContrastEnhancementFactor
int | AntiAlias
int | MaskOnSurface
double | MaskThreshold
double | MaskIntensity
double | MaskColor [3]
int | ColorMode
double | LICIntensity
double | MapModeBias
int | GenerateNoiseTexture
int | NoiseType
int | NoiseTextureSize
int | NoiseGrainSize
double | MinNoiseValue
double | MaxNoiseValue
int | NumberOfNoiseLevels
double | ImpulseNoiseProbability
double | ImpulseNoiseBackgroundValue
int | NoiseGeneratorSeed
int | AlwaysUpdate
int | CompositeStrategy
vtkSurfaceLICHelper * | Internals
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers
enum | { ENHANCE_CONTRAST_OFF = 0 , ENHANCE_CONTRAST_LIC = 1 , ENHANCE_CONTRAST_COLOR = 3 , ENHANCE_CONTRAST_BOTH = 4 }
| Enable/Disable contrast and dynamic range correction stages. More...
void | SetEnhanceContrast (int val)
| Enable/Disable contrast and dynamic range correction stages. More...
virtual int | GetEnhanceContrast ()
| Enable/Disable contrast and dynamic range correction stages. More...
enum | { COLOR_MODE_BLEND = 0 , COLOR_MODE_MAP }
| Set/Get the color mode. More...
void | SetColorMode (int val)
| Set/Get the color mode. More...
virtual int | GetColorMode ()
| Set/Get the color mode. More...
enum | { NOISE_TYPE_UNIFORM = 0 , NOISE_TYPE_GAUSSIAN = 1 , NOISE_TYPE_PERLIN = 2 }
| Select the statistical distribution of randomly generated noise values. More...
void | SetNoiseType (int type)
| Select the statistical distribution of randomly generated noise values. More...
virtual int | GetNoiseType ()
| Select the statistical distribution of randomly generated noise values. More...
enum | { COMPOSITE_INPLACE = 0 , COMPOSITE_INPLACE_DISJOINT = 1 , COMPOSITE_BALANCED = 2 , COMPOSITE_AUTO = 3 }
| Control the screen space decomposition where LIC is computed. More...
void | SetCompositeStrategy (int val)
| Control the screen space decomposition where LIC is computed. More...
virtual int | GetCompositeStrategy ()
| Control the screen space decomposition where LIC is computed. More...

## Additional Inherited Members
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

public API for surface lic parameters arbitrary geometry.

vtkSurfaceLICInterface performs LIC on the surface of arbitrary geometry. Point vectors are used as the vector field for generating the LIC. The implementation was originallu based on "Image Space Based Visualization on Unsteady Flow on Surfaces" by Laramee, Jobard and Hauser appeared in proceedings of IEEE Visualization '03, pages 131-138.

Internal pipeline:

    noise
        |
        [ PROJ (GAT) (COMP) LIC2D (SCAT) SHADE (CCE) DEP]
        |                                               |
    vectors                                         surface LIC

PROj - project vectors onto surface GAT - gather data for compositing and guard pixel generation (parallel only) COMP - composite gathered data LIC2D - line intengral convolution, see vtkLineIntegralConvolution2D. SCAT - scatter result (parallel only, not all compositors use it) SHADE - combine LIC and scalar colors CCE - color contrast enhancement (optional) DEP - depth test and copy to back buffer

The result of each stage is cached in a texture so that during interaction a stage may be skipped if the user has not modified its parameters or input data.

The parallel parts of algorithm are implemented in vtkPSurfaceLICInterface. Note that for MPI enabled builds this class will be automatically created by the object factory.

See also
  vtkLineIntegralConvolution2D

Tests:
  vtkSurfaceLICInterface (Tests)

Definition at line 64 of file vtkSurfaceLICInterface.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkObject vtkSurfaceLICInterface::Superclass

Definition at line 68 of file vtkSurfaceLICInterface.h.

## Member Enumeration Documentation

## ◆ anonymous enum

anonymous enum

Enable/Disable contrast and dynamic range correction stages.

Contrast enhancement can be enabled during LIC computations (See vtkLineINtegralComvolution2D) and after the scalar colors have been combined with the LIC.

The best approach for using this feature is to enable LIC enhancement, and only if the image is to dark or dull enable COLOR enhancement.

Both stages are implemented by a histogram stretching algorithm. During LIC stages the contrast enhancement is applied to gray scale LIC image. During the scalar coloring stage the contrast enhancement is applied to the lightness channel of the color image in HSL color space. The histogram stretching is implemented as follows:

L = (L-m)/(M-m)

where, L is the fragment intensity/lightness, m is the intensity/lightness to map to 0, M is the intensity/lightness to map to 1. The default values of m and M are the min and max taken over all fragments.

This increase the dynamic range and contrast in the LIC'd image, both of which are natuarly attenuated by the convolution process.

Values

ENHANCE_CONTRAST_OFF – don't enhance LIC or scalar colors ENHANCE_CONTRAST_LIC – enhance in LIC high-pass input and output ENHANCE_CONTRAST_COLOR – enhance after scalars are combined with LIC ENHANCE_CONTRAST_BOTH – enhance in LIC stages and after scalar colors

This feature is disabled by default.

Enumerator
ENHANCE_CONTRAST_OFF |
ENHANCE_CONTRAST_LIC |
ENHANCE_CONTRAST_COLOR |
ENHANCE_CONTRAST_BOTH |

Definition at line 209 of file vtkSurfaceLICInterface.h.

## ◆ anonymous enum

anonymous enum

Set/Get the color mode.

The color mode controls how scalar colors are combined with the LIC in the final image. The BLEND mode combines scalar colors with LIC intensities with proportional blending controlled by the LICIntensity parameter. The MAP mode combines scalar colors with LIC, by multiplication the HSL representation of color's lightness.

The default is COLOR_MODE_BLEND.

Enumerator
COLOR_MODE_BLEND |
COLOR_MODE_MAP |

Definition at line 270 of file vtkSurfaceLICInterface.h.

## ◆ anonymous enum

anonymous enum

Select the statistical distribution of randomly generated noise values.

With uniform noise there is greater control over the range of values in the noise texture. The Default is NOISE_TYPE_GAUSSIAN.

Enumerator
NOISE_TYPE_UNIFORM |
NOISE_TYPE_GAUSSIAN |
NOISE_TYPE_PERLIN |

Definition at line 345 of file vtkSurfaceLICInterface.h.

## ◆ anonymous enum

anonymous enum

Control the screen space decomposition where LIC is computed.

Enumerator
COMPOSITE_INPLACE |
COMPOSITE_INPLACE_DISJOINT |
COMPOSITE_BALANCED |
COMPOSITE_AUTO |

Definition at line 423 of file vtkSurfaceLICInterface.h.

## Constructor & Destructor Documentation

## ◆ vtkSurfaceLICInterface()

vtkSurfaceLICInterface::vtkSurfaceLICInterface | ( |  | ) |
| protected

## ◆ ~vtkSurfaceLICInterface()

vtkSurfaceLICInterface::~vtkSurfaceLICInterface | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkSurfaceLICInterface* vtkSurfaceLICInterface::New | ( |  | ) |
| static

## ◆ IsTypeOf()

static vtkTypeBool vtkSurfaceLICInterface::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkSurfaceLICInterface::IsA | ( | const char * | name | ) |
| virtual

Return 1 if this class is the same type of (or a subclass of) the named class.

Returns 0 otherwise. This method works in combination with vtkTypeMacro found in vtkSetGet.h.

Reimplemented from vtkObjectBase.

Reimplemented in vtkPSurfaceLICInterface.

## ◆ SafeDownCast()

static vtkSurfaceLICInterface* vtkSurfaceLICInterface::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkSurfaceLICInterface::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Reimplemented in vtkPSurfaceLICInterface.

## ◆ NewInstance()

vtkSurfaceLICInterface* vtkSurfaceLICInterface::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkSurfaceLICInterface::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkObject.

Reimplemented in vtkPSurfaceLICInterface.

## ◆ SetNumberOfSteps()

void vtkSurfaceLICInterface::SetNumberOfSteps | ( | int | val | ) |

Get/Set the number of integration steps in each direction.

## ◆ GetNumberOfSteps()

virtual int vtkSurfaceLICInterface::GetNumberOfSteps | ( |  | ) |
| virtual

Get/Set the number of integration steps in each direction.

## ◆ SetStepSize()

void vtkSurfaceLICInterface::SetStepSize | ( | double | val | ) |

Get/Set the step size (in pixels).

## ◆ GetStepSize()

virtual double vtkSurfaceLICInterface::GetStepSize | ( |  | ) |
| virtual

Get/Set the step size (in pixels).

## ◆ SetNormalizeVectors()

void vtkSurfaceLICInterface::SetNormalizeVectors | ( | int | val | ) |

Normalize vectors during integration.

When set(the default) the input vector field is normalized during integration, and each integration occurs over the same arclength. When not set each integration occurs over an arc length proportional to the field magnitude as is customary in traditional numerical methods. See, "Imaging Vector Fields Using Line Integral Convolution" for an axample where normalization is used. See, "Image Space Based Visualization of Unsteady Flow on Surfaces" for an example of where no normalization is used.

## ◆ NormalizeVectorsOn()

virtual void vtkSurfaceLICInterface::NormalizeVectorsOn | ( |  | ) |
| virtual

Normalize vectors during integration.

When set(the default) the input vector field is normalized during integration, and each integration occurs over the same arclength. When not set each integration occurs over an arc length proportional to the field magnitude as is customary in traditional numerical methods. See, "Imaging Vector Fields Using Line Integral Convolution" for an axample where normalization is used. See, "Image Space Based Visualization of Unsteady Flow on Surfaces" for an example of where no normalization is used.

## ◆ NormalizeVectorsOff()

virtual void vtkSurfaceLICInterface::NormalizeVectorsOff | ( |  | ) |
| virtual

Normalize vectors during integration.

When set(the default) the input vector field is normalized during integration, and each integration occurs over the same arclength. When not set each integration occurs over an arc length proportional to the field magnitude as is customary in traditional numerical methods. See, "Imaging Vector Fields Using Line Integral Convolution" for an axample where normalization is used. See, "Image Space Based Visualization of Unsteady Flow on Surfaces" for an example of where no normalization is used.

## ◆ GetNormalizeVectors()

virtual int vtkSurfaceLICInterface::GetNormalizeVectors | ( |  | ) |
| virtual

Normalize vectors during integration.

When set(the default) the input vector field is normalized during integration, and each integration occurs over the same arclength. When not set each integration occurs over an arc length proportional to the field magnitude as is customary in traditional numerical methods. See, "Imaging Vector Fields Using Line Integral Convolution" for an axample where normalization is used. See, "Image Space Based Visualization of Unsteady Flow on Surfaces" for an example of where no normalization is used.

## ◆ SetMaskOnSurface()

void vtkSurfaceLICInterface::SetMaskOnSurface | ( | int | val | ) |

When set MaskOnSurface computes |V| for use in the fragment masking tests on the surface.

When not set the original un-projected un-transformed |V| is used.

## ◆ MaskOnSurfaceOn()

virtual void vtkSurfaceLICInterface::MaskOnSurfaceOn | ( |  | ) |
| virtual

When set MaskOnSurface computes |V| for use in the fragment masking tests on the surface.

When not set the original un-projected un-transformed |V| is used.

## ◆ MaskOnSurfaceOff()

virtual void vtkSurfaceLICInterface::MaskOnSurfaceOff | ( |  | ) |
| virtual

When set MaskOnSurface computes |V| for use in the fragment masking tests on the surface.

When not set the original un-projected un-transformed |V| is used.

## ◆ GetMaskOnSurface()

virtual int vtkSurfaceLICInterface::GetMaskOnSurface | ( |  | ) |
| virtual

When set MaskOnSurface computes |V| for use in the fragment masking tests on the surface.

When not set the original un-projected un-transformed |V| is used.

## ◆ SetMaskThreshold()

void vtkSurfaceLICInterface::SetMaskThreshold | ( | double | val | ) |

The MaskThreshold controls the rendering of fragments in stagnant regions of flow.

// In these regions LIC noise texture will be masked, where |V| < MaskThreshold is satisfied. The masking process blends a the MaskColor with the scalar color of the surface proportional to MaskIntesnsity. See MaskIntensity for more information on the blending algorithm. This blending allows one control over the masking process so that masked fragments may be: highlighted (by setting a unique mask color and mask intensity > 0), made invisible with and without passing the un-convolved noise texture (by setting mask intensity 0), made to blend into the LIC.

MaskThreshold units are in the original vector space. Note that the threshold can be applied to the original vector field or to the surface projected vector field. See MaskOnSurface.

## ◆ GetMaskThreshold()

virtual double vtkSurfaceLICInterface::GetMaskThreshold | ( |  | ) |
| virtual

The MaskThreshold controls the rendering of fragments in stagnant regions of flow.

// In these regions LIC noise texture will be masked, where |V| < MaskThreshold is satisfied. The masking process blends a the MaskColor with the scalar color of the surface proportional to MaskIntesnsity. See MaskIntensity for more information on the blending algorithm. This blending allows one control over the masking process so that masked fragments may be: highlighted (by setting a unique mask color and mask intensity > 0), made invisible with and without passing the un-convolved noise texture (by setting mask intensity 0), made to blend into the LIC.

MaskThreshold units are in the original vector space. Note that the threshold can be applied to the original vector field or to the surface projected vector field. See MaskOnSurface.

## ◆ SetMaskColor() [1/2]

void vtkSurfaceLICInterface::SetMaskColor | ( | double * | val | ) |

The MaskColor is used on masked fragments.

The default of (0.5, 0.5, 0.5) makes the masked fragments look similar to the LIC'd fragments. The mask color is applied only when MaskIntensity > 0.

## ◆ SetMaskColor() [2/2]

void vtkSurfaceLICInterface::SetMaskColor | ( | double | r,
|  | double | g,
|  | double | b
| ) |  |
| inline

The MaskColor is used on masked fragments.

The default of (0.5, 0.5, 0.5) makes the masked fragments look similar to the LIC'd fragments. The mask color is applied only when MaskIntensity > 0.

Definition at line 143 of file vtkSurfaceLICInterface.h.

## ◆ GetMaskColor() [1/3]

virtual double* vtkSurfaceLICInterface::GetMaskColor | ( |  | ) |
| virtual

The MaskColor is used on masked fragments.

The default of (0.5, 0.5, 0.5) makes the masked fragments look similar to the LIC'd fragments. The mask color is applied only when MaskIntensity > 0.

## ◆ GetMaskColor() [2/3]

virtual void vtkSurfaceLICInterface::GetMaskColor | ( | double & | ,
|  | double & | ,
|  | double & |
| ) |  |
| virtual

The MaskColor is used on masked fragments.

The default of (0.5, 0.5, 0.5) makes the masked fragments look similar to the LIC'd fragments. The mask color is applied only when MaskIntensity > 0.

## ◆ GetMaskColor() [3/3]

virtual void vtkSurfaceLICInterface::GetMaskColor | ( | double | [3] | ) |
| virtual

The MaskColor is used on masked fragments.

The default of (0.5, 0.5, 0.5) makes the masked fragments look similar to the LIC'd fragments. The mask color is applied only when MaskIntensity > 0.

## ◆ SetMaskIntensity()

void vtkSurfaceLICInterface::SetMaskIntensity | ( | double | val | ) |

The MaskIntensity controls the blending of the mask color and the geometry color.

The color of masked fragments is given by:

c = maskColor * maskIntensity + geomColor * (1 - maskIntensity)

The default value of 0.0 results in the geometry color being used.

## ◆ GetMaskIntensity()

virtual double vtkSurfaceLICInterface::GetMaskIntensity | ( |  | ) |
| virtual

The MaskIntensity controls the blending of the mask color and the geometry color.

The color of masked fragments is given by:

c = maskColor * maskIntensity + geomColor * (1 - maskIntensity)

The default value of 0.0 results in the geometry color being used.

## ◆ SetEnhancedLIC()

void vtkSurfaceLICInterface::SetEnhancedLIC | ( | int | val | ) |

EnhancedLIC mean compute the LIC twice with the second pass using the edge-enhanced result of the first pass as a noise texture.

Edge enhancedment is made by a simple Laplace convolution.

## ◆ GetEnhancedLIC()

virtual int vtkSurfaceLICInterface::GetEnhancedLIC | ( |  | ) |
| virtual

EnhancedLIC mean compute the LIC twice with the second pass using the edge-enhanced result of the first pass as a noise texture.

Edge enhancedment is made by a simple Laplace convolution.

## ◆ EnhancedLICOn()

virtual void vtkSurfaceLICInterface::EnhancedLICOn | ( |  | ) |
| virtual

EnhancedLIC mean compute the LIC twice with the second pass using the edge-enhanced result of the first pass as a noise texture.

Edge enhancedment is made by a simple Laplace convolution.

## ◆ EnhancedLICOff()

virtual void vtkSurfaceLICInterface::EnhancedLICOff | ( |  | ) |
| virtual

EnhancedLIC mean compute the LIC twice with the second pass using the edge-enhanced result of the first pass as a noise texture.

Edge enhancedment is made by a simple Laplace convolution.

## ◆ SetEnhanceContrast()

void vtkSurfaceLICInterface::SetEnhanceContrast | ( | int | val | ) |

Enable/Disable contrast and dynamic range correction stages.

Contrast enhancement can be enabled during LIC computations (See vtkLineINtegralComvolution2D) and after the scalar colors have been combined with the LIC.

The best approach for using this feature is to enable LIC enhancement, and only if the image is to dark or dull enable COLOR enhancement.

Both stages are implemented by a histogram stretching algorithm. During LIC stages the contrast enhancement is applied to gray scale LIC image. During the scalar coloring stage the contrast enhancement is applied to the lightness channel of the color image in HSL color space. The histogram stretching is implemented as follows:

L = (L-m)/(M-m)

where, L is the fragment intensity/lightness, m is the intensity/lightness to map to 0, M is the intensity/lightness to map to 1. The default values of m and M are the min and max taken over all fragments.

This increase the dynamic range and contrast in the LIC'd image, both of which are natuarly attenuated by the convolution process.

Values

ENHANCE_CONTRAST_OFF – don't enhance LIC or scalar colors ENHANCE_CONTRAST_LIC – enhance in LIC high-pass input and output ENHANCE_CONTRAST_COLOR – enhance after scalars are combined with LIC ENHANCE_CONTRAST_BOTH – enhance in LIC stages and after scalar colors

This feature is disabled by default.

## ◆ GetEnhanceContrast()

virtual int vtkSurfaceLICInterface::GetEnhanceContrast | ( |  | ) |
| virtual

Enable/Disable contrast and dynamic range correction stages.

Contrast enhancement can be enabled during LIC computations (See vtkLineINtegralComvolution2D) and after the scalar colors have been combined with the LIC.

The best approach for using this feature is to enable LIC enhancement, and only if the image is to dark or dull enable COLOR enhancement.

Both stages are implemented by a histogram stretching algorithm. During LIC stages the contrast enhancement is applied to gray scale LIC image. During the scalar coloring stage the contrast enhancement is applied to the lightness channel of the color image in HSL color space. The histogram stretching is implemented as follows:

L = (L-m)/(M-m)

where, L is the fragment intensity/lightness, m is the intensity/lightness to map to 0, M is the intensity/lightness to map to 1. The default values of m and M are the min and max taken over all fragments.

This increase the dynamic range and contrast in the LIC'd image, both of which are natuarly attenuated by the convolution process.

Values

ENHANCE_CONTRAST_OFF – don't enhance LIC or scalar colors ENHANCE_CONTRAST_LIC – enhance in LIC high-pass input and output ENHANCE_CONTRAST_COLOR – enhance after scalars are combined with LIC ENHANCE_CONTRAST_BOTH – enhance in LIC stages and after scalar colors

This feature is disabled by default.

## ◆ GetLowLICContrastEnhancementFactor()

virtual double vtkSurfaceLICInterface::GetLowLICContrastEnhancementFactor | ( |  | ) |
| virtual

This feature is used to fine tune the contrast enhancement.

There are two modes AUTOMATIC and MANUAL.In AUTOMATIC mode values are provided indicating the fraction of the range to adjust M and m by, during contrast enahncement histogram stretching. M and m are the intensity/lightness values that map to 1 and 0. (see EnhanceContrast for an explanation of the mapping procedure). m and M are computed using the factors as follows:

m = min(C) + mFactor * (max(C) - min(C)) M = max(C) - MFactor * (max(C) - min(C))

the default values for mFactor and MFactor are 0 which result in m = min(C), M = max(C), taken over the entire image. Modifying mFactor and MFactor above or below zero provide control over the saturation/ de-saturation during contrast enhancement.

## ◆ GetHighLICContrastEnhancementFactor()

virtual double vtkSurfaceLICInterface::GetHighLICContrastEnhancementFactor | ( |  | ) |
| virtual

This feature is used to fine tune the contrast enhancement.

There are two modes AUTOMATIC and MANUAL.In AUTOMATIC mode values are provided indicating the fraction of the range to adjust M and m by, during contrast enahncement histogram stretching. M and m are the intensity/lightness values that map to 1 and 0. (see EnhanceContrast for an explanation of the mapping procedure). m and M are computed using the factors as follows:

m = min(C) + mFactor * (max(C) - min(C)) M = max(C) - MFactor * (max(C) - min(C))

the default values for mFactor and MFactor are 0 which result in m = min(C), M = max(C), taken over the entire image. Modifying mFactor and MFactor above or below zero provide control over the saturation/ de-saturation during contrast enhancement.

## ◆ SetLowLICContrastEnhancementFactor()

void vtkSurfaceLICInterface::SetLowLICContrastEnhancementFactor | ( | double | val | ) |

This feature is used to fine tune the contrast enhancement.

There are two modes AUTOMATIC and MANUAL.In AUTOMATIC mode values are provided indicating the fraction of the range to adjust M and m by, during contrast enahncement histogram stretching. M and m are the intensity/lightness values that map to 1 and 0. (see EnhanceContrast for an explanation of the mapping procedure). m and M are computed using the factors as follows:

m = min(C) + mFactor * (max(C) - min(C)) M = max(C) - MFactor * (max(C) - min(C))

the default values for mFactor and MFactor are 0 which result in m = min(C), M = max(C), taken over the entire image. Modifying mFactor and MFactor above or below zero provide control over the saturation/ de-saturation during contrast enhancement.

## ◆ SetHighLICContrastEnhancementFactor()

void vtkSurfaceLICInterface::SetHighLICContrastEnhancementFactor | ( | double | val | ) |

This feature is used to fine tune the contrast enhancement.

There are two modes AUTOMATIC and MANUAL.In AUTOMATIC mode values are provided indicating the fraction of the range to adjust M and m by, during contrast enahncement histogram stretching. M and m are the intensity/lightness values that map to 1 and 0. (see EnhanceContrast for an explanation of the mapping procedure). m and M are computed using the factors as follows:

m = min(C) + mFactor * (max(C) - min(C)) M = max(C) - MFactor * (max(C) - min(C))

the default values for mFactor and MFactor are 0 which result in m = min(C), M = max(C), taken over the entire image. Modifying mFactor and MFactor above or below zero provide control over the saturation/ de-saturation during contrast enhancement.

## ◆ GetLowColorContrastEnhancementFactor()

virtual double vtkSurfaceLICInterface::GetLowColorContrastEnhancementFactor | ( |  | ) |
| virtual

This feature is used to fine tune the contrast enhancement.

There are two modes AUTOMATIC and MANUAL.In AUTOMATIC mode values are provided indicating the fraction of the range to adjust M and m by, during contrast enahncement histogram stretching. M and m are the intensity/lightness values that map to 1 and 0. (see EnhanceContrast for an explanation of the mapping procedure). m and M are computed using the factors as follows:

m = min(C) + mFactor * (max(C) - min(C)) M = max(C) - MFactor * (max(C) - min(C))

the default values for mFactor and MFactor are 0 which result in m = min(C), M = max(C), taken over the entire image. Modifying mFactor and MFactor above or below zero provide control over the saturation/ de-saturation during contrast enhancement.

## ◆ GetHighColorContrastEnhancementFactor()

virtual double vtkSurfaceLICInterface::GetHighColorContrastEnhancementFactor | ( |  | ) |
| virtual

This feature is used to fine tune the contrast enhancement.

There are two modes AUTOMATIC and MANUAL.In AUTOMATIC mode values are provided indicating the fraction of the range to adjust M and m by, during contrast enahncement histogram stretching. M and m are the intensity/lightness values that map to 1 and 0. (see EnhanceContrast for an explanation of the mapping procedure). m and M are computed using the factors as follows:

m = min(C) + mFactor * (max(C) - min(C)) M = max(C) - MFactor * (max(C) - min(C))

the default values for mFactor and MFactor are 0 which result in m = min(C), M = max(C), taken over the entire image. Modifying mFactor and MFactor above or below zero provide control over the saturation/ de-saturation during contrast enhancement.

## ◆ SetLowColorContrastEnhancementFactor()

void vtkSurfaceLICInterface::SetLowColorContrastEnhancementFactor | ( | double | val | ) |

This feature is used to fine tune the contrast enhancement.

There are two modes AUTOMATIC and MANUAL.In AUTOMATIC mode values are provided indicating the fraction of the range to adjust M and m by, during contrast enahncement histogram stretching. M and m are the intensity/lightness values that map to 1 and 0. (see EnhanceContrast for an explanation of the mapping procedure). m and M are computed using the factors as follows:

m = min(C) + mFactor * (max(C) - min(C)) M = max(C) - MFactor * (max(C) - min(C))

the default values for mFactor and MFactor are 0 which result in m = min(C), M = max(C), taken over the entire image. Modifying mFactor and MFactor above or below zero provide control over the saturation/ de-saturation during contrast enhancement.

## ◆ SetHighColorContrastEnhancementFactor()

void vtkSurfaceLICInterface::SetHighColorContrastEnhancementFactor | ( | double | val | ) |

This feature is used to fine tune the contrast enhancement.

There are two modes AUTOMATIC and MANUAL.In AUTOMATIC mode values are provided indicating the fraction of the range to adjust M and m by, during contrast enahncement histogram stretching. M and m are the intensity/lightness values that map to 1 and 0. (see EnhanceContrast for an explanation of the mapping procedure). m and M are computed using the factors as follows:

m = min(C) + mFactor * (max(C) - min(C)) M = max(C) - MFactor * (max(C) - min(C))

the default values for mFactor and MFactor are 0 which result in m = min(C), M = max(C), taken over the entire image. Modifying mFactor and MFactor above or below zero provide control over the saturation/ de-saturation during contrast enhancement.

## ◆ SetAntiAlias()

void vtkSurfaceLICInterface::SetAntiAlias | ( | int | val | ) |

Enable/Disable the anti-aliasing pass.

This optional pass (disabled by default) can be enabled to reduce jagged patterns in the final LIC image. Values greater than 0 control the number of iterations, 1 is typically sufficient.

## ◆ AntiAliasOn()

virtual void vtkSurfaceLICInterface::AntiAliasOn | ( |  | ) |
| virtual

Enable/Disable the anti-aliasing pass.

This optional pass (disabled by default) can be enabled to reduce jagged patterns in the final LIC image. Values greater than 0 control the number of iterations, 1 is typically sufficient.

## ◆ AntiAliasOff()

virtual void vtkSurfaceLICInterface::AntiAliasOff | ( |  | ) |
| virtual

Enable/Disable the anti-aliasing pass.

This optional pass (disabled by default) can be enabled to reduce jagged patterns in the final LIC image. Values greater than 0 control the number of iterations, 1 is typically sufficient.

## ◆ GetAntiAlias()

virtual int vtkSurfaceLICInterface::GetAntiAlias | ( |  | ) |
| virtual

Enable/Disable the anti-aliasing pass.

This optional pass (disabled by default) can be enabled to reduce jagged patterns in the final LIC image. Values greater than 0 control the number of iterations, 1 is typically sufficient.

## ◆ SetColorMode()

void vtkSurfaceLICInterface::SetColorMode | ( | int | val | ) |

Set/Get the color mode.

The color mode controls how scalar colors are combined with the LIC in the final image. The BLEND mode combines scalar colors with LIC intensities with proportional blending controlled by the LICIntensity parameter. The MAP mode combines scalar colors with LIC, by multiplication the HSL representation of color's lightness.

The default is COLOR_MODE_BLEND.

## ◆ GetColorMode()

virtual int vtkSurfaceLICInterface::GetColorMode | ( |  | ) |
| virtual

Set/Get the color mode.

The color mode controls how scalar colors are combined with the LIC in the final image. The BLEND mode combines scalar colors with LIC intensities with proportional blending controlled by the LICIntensity parameter. The MAP mode combines scalar colors with LIC, by multiplication the HSL representation of color's lightness.

The default is COLOR_MODE_BLEND.

## ◆ SetLICIntensity()

void vtkSurfaceLICInterface::SetLICIntensity | ( | double | val | ) |

Factor used when blend mode is set to COLOR_MODE_BLEND.

This controls the contribution of the LIC in the final output image as follows:

c = LIC * LICIntensity + scalar * (1 - LICIntensity);

0.0 produces same result as disabling LIC altogether, while 1.0 implies show LIC result alone.

## ◆ GetLICIntensity()

virtual double vtkSurfaceLICInterface::GetLICIntensity | ( |  | ) |
| virtual

Factor used when blend mode is set to COLOR_MODE_BLEND.

This controls the contribution of the LIC in the final output image as follows:

c = LIC * LICIntensity + scalar * (1 - LICIntensity);

0.0 produces same result as disabling LIC altogether, while 1.0 implies show LIC result alone.

## ◆ SetMapModeBias()

void vtkSurfaceLICInterface::SetMapModeBias | ( | double | val | ) |

Factor used when blend mode is set to COLOR_MODE_MAP.

This adds a bias to the LIC image. The purpose of this is to adjust the brightness when a brighter image is desired. The default of 0.0 results in no change. Values gretaer than 0.0 will brighten the image while values less than 0.0 darken the image.

## ◆ GetMapModeBias()

virtual double vtkSurfaceLICInterface::GetMapModeBias | ( |  | ) |
| virtual

Factor used when blend mode is set to COLOR_MODE_MAP.

This adds a bias to the LIC image. The purpose of this is to adjust the brightness when a brighter image is desired. The default of 0.0 results in no change. Values gretaer than 0.0 will brighten the image while values less than 0.0 darken the image.

## ◆ SetNoiseDataSet()

void vtkSurfaceLICInterface::SetNoiseDataSet | ( | vtkImageData * | data | ) |

Set the data containing a noise array as active scalars.

Active scalars array will be converted into a texture for use as noise in the LIC process. Noise datasets are expected to be gray scale.

## ◆ GetNoiseDataSet()

vtkImageData* vtkSurfaceLICInterface::GetNoiseDataSet | ( |  | ) |

Set the data containing a noise array as active scalars.

Active scalars array will be converted into a texture for use as noise in the LIC process. Noise datasets are expected to be gray scale.

## ◆ SetGenerateNoiseTexture()

void vtkSurfaceLICInterface::SetGenerateNoiseTexture | ( | int | shouldGenerate | ) |

Set/Get the noise texture source.

When not set the default 200x200 white noise texture is used (see VTKData/Data/Data/noise.png). When set a noise texture is generated based on the following parameters:

NoiseType - select noise type. Gaussian, Uniform, etc NoiseTextureSize - number of pixels in square noise texture(side) NoiseGrainSize - number of pixels each noise value spans(side) MinNoiseValue - minimum noise color >=0 && < MaxNoiseValue MaxNoiseValue - maximum noise color <=1 ** > MinNoiseValue NumberOfNoiseLevels - number of discrete noise colors ImpulseNoiseProbability - impulse noise is generated when < 1 ImpulseNoiseBackgroundValue - the background color for untouched pixels NoiseGeneratorSeed - seed the random number generators

Changing the noise texture gives one greater control over the look of the final image. The default is 0 which results in the use of a static 200x200 Gaussian noise texture. See VTKData/Data/Data/noise.png.

## ◆ GetGenerateNoiseTexture()

virtual int vtkSurfaceLICInterface::GetGenerateNoiseTexture | ( |  | ) |
| virtual

Set/Get the noise texture source.

When not set the default 200x200 white noise texture is used (see VTKData/Data/Data/noise.png). When set a noise texture is generated based on the following parameters:

NoiseType - select noise type. Gaussian, Uniform, etc NoiseTextureSize - number of pixels in square noise texture(side) NoiseGrainSize - number of pixels each noise value spans(side) MinNoiseValue - minimum noise color >=0 && < MaxNoiseValue MaxNoiseValue - maximum noise color <=1 ** > MinNoiseValue NumberOfNoiseLevels - number of discrete noise colors ImpulseNoiseProbability - impulse noise is generated when < 1 ImpulseNoiseBackgroundValue - the background color for untouched pixels NoiseGeneratorSeed - seed the random number generators

Changing the noise texture gives one greater control over the look of the final image. The default is 0 which results in the use of a static 200x200 Gaussian noise texture. See VTKData/Data/Data/noise.png.

## ◆ SetNoiseType()

void vtkSurfaceLICInterface::SetNoiseType | ( | int | type | ) |

Select the statistical distribution of randomly generated noise values.

With uniform noise there is greater control over the range of values in the noise texture. The Default is NOISE_TYPE_GAUSSIAN.

## ◆ GetNoiseType()

virtual int vtkSurfaceLICInterface::GetNoiseType | ( |  | ) |
| virtual

Select the statistical distribution of randomly generated noise values.

With uniform noise there is greater control over the range of values in the noise texture. The Default is NOISE_TYPE_GAUSSIAN.

## ◆ SetNoiseTextureSize()

void vtkSurfaceLICInterface::SetNoiseTextureSize | ( | int | length | ) |

Set/Get the side length in pixels of the noise texture.

The texture will be length^2 pixels in area.

## ◆ GetNoiseTextureSize()

virtual int vtkSurfaceLICInterface::GetNoiseTextureSize | ( |  | ) |
| virtual

Set/Get the side length in pixels of the noise texture.

The texture will be length^2 pixels in area.

## ◆ SetNoiseGrainSize()

void vtkSurfaceLICInterface::SetNoiseGrainSize | ( | int | val | ) |

Each noise value will be length^2 pixels in area.

## ◆ GetNoiseGrainSize()

virtual int vtkSurfaceLICInterface::GetNoiseGrainSize | ( |  | ) |
| virtual

Each noise value will be length^2 pixels in area.

## ◆ SetMinNoiseValue()

void vtkSurfaceLICInterface::SetMinNoiseValue | ( | double | val | ) |

Set/Get the minimum and mximum gray scale values that the generated noise can take on.

The generated noise will be in the range of MinNoiseValue to MaxNoiseValue. Values are clamped within 0 to 1. MinNoiseValue must be less than MaxNoiseValue.

## ◆ SetMaxNoiseValue()

void vtkSurfaceLICInterface::SetMaxNoiseValue | ( | double | val | ) |

Set/Get the minimum and mximum gray scale values that the generated noise can take on.

The generated noise will be in the range of MinNoiseValue to MaxNoiseValue. Values are clamped within 0 to 1. MinNoiseValue must be less than MaxNoiseValue.

## ◆ GetMinNoiseValue()

virtual double vtkSurfaceLICInterface::GetMinNoiseValue | ( |  | ) |
| virtual

Set/Get the minimum and mximum gray scale values that the generated noise can take on.

The generated noise will be in the range of MinNoiseValue to MaxNoiseValue. Values are clamped within 0 to 1. MinNoiseValue must be less than MaxNoiseValue.

## ◆ GetMaxNoiseValue()

virtual double vtkSurfaceLICInterface::GetMaxNoiseValue | ( |  | ) |
| virtual

Set/Get the minimum and mximum gray scale values that the generated noise can take on.

The generated noise will be in the range of MinNoiseValue to MaxNoiseValue. Values are clamped within 0 to 1. MinNoiseValue must be less than MaxNoiseValue.

## ◆ SetNumberOfNoiseLevels()

void vtkSurfaceLICInterface::SetNumberOfNoiseLevels | ( | int | val | ) |

Set/Get the number of discrete values a noise pixel may take on.

Default 1024.

## ◆ GetNumberOfNoiseLevels()

virtual int vtkSurfaceLICInterface::GetNumberOfNoiseLevels | ( |  | ) |
| virtual

Set/Get the number of discrete values a noise pixel may take on.

Default 1024.

## ◆ SetImpulseNoiseProbability()

void vtkSurfaceLICInterface::SetImpulseNoiseProbability | ( | double | val | ) |

Control the density of the noise.

A value of 1.0 produces uniform random noise while values < 1.0 produce impulse noise with the given probability.

## ◆ GetImpulseNoiseProbability()

virtual double vtkSurfaceLICInterface::GetImpulseNoiseProbability | ( |  | ) |
| virtual

Control the density of the noise.

A value of 1.0 produces uniform random noise while values < 1.0 produce impulse noise with the given probability.

## ◆ SetImpulseNoiseBackgroundValue()

void vtkSurfaceLICInterface::SetImpulseNoiseBackgroundValue | ( | double | val | ) |

The color to use for untouched pixels when impulse noise probability < 1.

## ◆ GetImpulseNoiseBackgroundValue()

virtual double vtkSurfaceLICInterface::GetImpulseNoiseBackgroundValue | ( |  | ) |
| virtual

The color to use for untouched pixels when impulse noise probability < 1.

## ◆ SetNoiseGeneratorSeed()

void vtkSurfaceLICInterface::SetNoiseGeneratorSeed | ( | int | val | ) |

Set/Get the seed value used by the random number generator.

## ◆ GetNoiseGeneratorSeed()

virtual int vtkSurfaceLICInterface::GetNoiseGeneratorSeed | ( |  | ) |
| virtual

Set/Get the seed value used by the random number generator.

## ◆ SetCompositeStrategy()

void vtkSurfaceLICInterface::SetCompositeStrategy | ( | int | val | ) |

Control the screen space decomposition where LIC is computed.

## ◆ GetCompositeStrategy()

virtual int vtkSurfaceLICInterface::GetCompositeStrategy | ( |  | ) |
| virtual

Control the screen space decomposition where LIC is computed.

## ◆ IsSupported()

static bool vtkSurfaceLICInterface::IsSupported | ( | vtkRenderWindow * | context | ) |
| static

Returns true if the rendering context supports extensions needed by this painter.

## ◆ WriteTimerLog()

virtual void vtkSurfaceLICInterface::WriteTimerLog | ( | const char * |  | ) |
| inlinevirtual

Methods used for parallel benchmarks.

Use cmake to define vtkSurfaceLICMapperTIME to enable benchmarks. During each update timing information is stored, it can be written to disk by calling WriteLog.

Definition at line 446 of file vtkSurfaceLICInterface.h.

## ◆ ShallowCopy()

void vtkSurfaceLICInterface::ShallowCopy | ( | vtkSurfaceLICInterface * | m | ) |

Make a shallow copy of this interface.

## ◆ ReleaseGraphicsResources()

virtual void vtkSurfaceLICInterface::ReleaseGraphicsResources | ( | vtkWindow * | win | ) |
| virtual

Release any graphics resources that are being consumed by this mapper.

The parameter window could be used to determine which graphic resources to release. In this case, releases the display lists.

## ◆ CanRenderSurfaceLIC()

bool vtkSurfaceLICInterface::CanRenderSurfaceLIC | ( | vtkActor * | actor | ) |

Returns true when rendering LIC is possible.

## ◆ ValidateContext()

void vtkSurfaceLICInterface::ValidateContext | ( | vtkRenderer * | renderer | ) |

Look for changes that would trigger stage updates.

## ◆ CreateCommunicator() [1/2]

virtual vtkPainterCommunicator* vtkSurfaceLICInterface::CreateCommunicator | ( | int |  | ) |
| virtual

Creates a new communicator with/without the calling processes as indicated by the passed in flag, if not 0 the calling process is included in the new communicator.

In parallel this call is mpi collective on the world communicator. In serial this is a no-op.

Reimplemented in vtkPSurfaceLICInterface.

## ◆ CreateCommunicator() [2/2]

void vtkSurfaceLICInterface::CreateCommunicator | ( | vtkRenderer * | ,
|  | vtkActor * | ,
|  | vtkDataObject * | data
| ) |  |

Creates a new communicator for internal use based on this rank's visible data.

## ◆ GetCommunicator()

vtkPainterCommunicator* vtkSurfaceLICInterface::GetCommunicator | ( |  | ) |

## ◆ UpdateCommunicator()

void vtkSurfaceLICInterface::UpdateCommunicator | ( | vtkRenderer * | renderer,
|  | vtkActor * | actor,
|  | vtkDataObject * | data
| ) |  |

Called from a mapper, does what is needed to make sure the communicators are ready.

## ◆ SetHasVectors()

void vtkSurfaceLICInterface::SetHasVectors | ( | bool | val | ) |

Does the data have vectors which we require.

## ◆ GetHasVectors()

bool vtkSurfaceLICInterface::GetHasVectors | ( |  | ) |

Does the data have vectors which we require.

## ◆ InitializeResources()

void vtkSurfaceLICInterface::InitializeResources | ( |  | ) |

resoucre allocators

## ◆ PrepareForGeometry()

void vtkSurfaceLICInterface::PrepareForGeometry | ( |  | ) |

## ◆ CompletedGeometry()

void vtkSurfaceLICInterface::CompletedGeometry | ( |  | ) |

## ◆ GatherVectors()

void vtkSurfaceLICInterface::GatherVectors | ( |  | ) |

## ◆ ApplyLIC()

void vtkSurfaceLICInterface::ApplyLIC | ( |  | ) |

## ◆ CombineColorsAndLIC()

void vtkSurfaceLICInterface::CombineColorsAndLIC | ( |  | ) |

## ◆ CopyToScreen()

void vtkSurfaceLICInterface::CopyToScreen | ( |  | ) |

## ◆ GetGlobalMinMax()

virtual void vtkSurfaceLICInterface::GetGlobalMinMax | ( | vtkPainterCommunicator * | ,
|  | float & | ,
|  | float & |
| ) |  |
| inlinevirtual

Get the min/max across all ranks.

min/max are in/out. In serial operation this is a no-op, in parallel it is a global collective reduction.

Reimplemented in vtkPSurfaceLICInterface.

Definition at line 517 of file vtkSurfaceLICInterface.h.

## ◆ SetEnable()

virtual void vtkSurfaceLICInterface::SetEnable | ( | int |  | ) |
| virtual

Enable/Disable LIC.

## ◆ GetEnable()

virtual int vtkSurfaceLICInterface::GetEnable | ( |  | ) |
| virtual

Enable/Disable LIC.

## ◆ EnableOn()

virtual void vtkSurfaceLICInterface::EnableOn | ( |  | ) |
| virtual

Enable/Disable LIC.

## ◆ EnableOff()

virtual void vtkSurfaceLICInterface::EnableOff | ( |  | ) |
| virtual

Enable/Disable LIC.

## ◆ UpdateNoiseImage()

void vtkSurfaceLICInterface::UpdateNoiseImage | ( | vtkRenderWindow * | renWin | ) |
| protected

Updates the noise texture, downsampling by the requested sample rate.

## ◆ NeedToUpdateCommunicator()

virtual bool vtkSurfaceLICInterface::NeedToUpdateCommunicator | ( |  | ) |
| protectedvirtual

Return false if stage can be skipped.

Reimplemented in vtkPSurfaceLICInterface.

## ◆ NeedToRenderGeometry()

bool vtkSurfaceLICInterface::NeedToRenderGeometry | ( | vtkRenderer * | renderer,
|  | vtkActor * | actor
| ) |  |
| protected

Return false if stage can be skipped.

## ◆ NeedToGatherVectors()

bool vtkSurfaceLICInterface::NeedToGatherVectors | ( |  | ) |
| protected

Return false if stage can be skipped.

## ◆ NeedToComputeLIC()

bool vtkSurfaceLICInterface::NeedToComputeLIC | ( |  | ) |
| protected

Return false if stage can be skipped.

## ◆ NeedToColorLIC()

bool vtkSurfaceLICInterface::NeedToColorLIC | ( |  | ) |
| protected

Return false if stage can be skipped.

## ◆ SetUpdateAll()

void vtkSurfaceLICInterface::SetUpdateAll | ( |  | ) |
| protected

Return false if stage can be skipped.

## Member Data Documentation

## ◆ Enable

int vtkSurfaceLICInterface::Enable
| protected

Definition at line 549 of file vtkSurfaceLICInterface.h.

## ◆ NumberOfSteps

int vtkSurfaceLICInterface::NumberOfSteps
| protected

Definition at line 552 of file vtkSurfaceLICInterface.h.

## ◆ StepSize

double vtkSurfaceLICInterface::StepSize
| protected

Definition at line 553 of file vtkSurfaceLICInterface.h.

## ◆ NormalizeVectors

int vtkSurfaceLICInterface::NormalizeVectors
| protected

Definition at line 554 of file vtkSurfaceLICInterface.h.

## ◆ EnhancedLIC

int vtkSurfaceLICInterface::EnhancedLIC
| protected

Definition at line 556 of file vtkSurfaceLICInterface.h.

## ◆ EnhanceContrast

int vtkSurfaceLICInterface::EnhanceContrast
| protected

Definition at line 557 of file vtkSurfaceLICInterface.h.

## ◆ LowLICContrastEnhancementFactor

double vtkSurfaceLICInterface::LowLICContrastEnhancementFactor
| protected

Definition at line 558 of file vtkSurfaceLICInterface.h.

## ◆ HighLICContrastEnhancementFactor

double vtkSurfaceLICInterface::HighLICContrastEnhancementFactor
| protected

Definition at line 559 of file vtkSurfaceLICInterface.h.

## ◆ LowColorContrastEnhancementFactor

double vtkSurfaceLICInterface::LowColorContrastEnhancementFactor
| protected

Definition at line 560 of file vtkSurfaceLICInterface.h.

## ◆ HighColorContrastEnhancementFactor

double vtkSurfaceLICInterface::HighColorContrastEnhancementFactor
| protected

Definition at line 561 of file vtkSurfaceLICInterface.h.

## ◆ AntiAlias

int vtkSurfaceLICInterface::AntiAlias
| protected

Definition at line 562 of file vtkSurfaceLICInterface.h.

## ◆ MaskOnSurface

int vtkSurfaceLICInterface::MaskOnSurface
| protected

Definition at line 564 of file vtkSurfaceLICInterface.h.

## ◆ MaskThreshold

double vtkSurfaceLICInterface::MaskThreshold
| protected

Definition at line 565 of file vtkSurfaceLICInterface.h.

## ◆ MaskIntensity

double vtkSurfaceLICInterface::MaskIntensity
| protected

Definition at line 566 of file vtkSurfaceLICInterface.h.

## ◆ MaskColor

double vtkSurfaceLICInterface::MaskColor[3]
| protected

Definition at line 567 of file vtkSurfaceLICInterface.h.

## ◆ ColorMode

int vtkSurfaceLICInterface::ColorMode
| protected

Definition at line 569 of file vtkSurfaceLICInterface.h.

## ◆ LICIntensity

double vtkSurfaceLICInterface::LICIntensity
| protected

Definition at line 570 of file vtkSurfaceLICInterface.h.

## ◆ MapModeBias

double vtkSurfaceLICInterface::MapModeBias
| protected

Definition at line 571 of file vtkSurfaceLICInterface.h.

## ◆ GenerateNoiseTexture

int vtkSurfaceLICInterface::GenerateNoiseTexture
| protected

Definition at line 573 of file vtkSurfaceLICInterface.h.

## ◆ NoiseType

int vtkSurfaceLICInterface::NoiseType
| protected

Definition at line 574 of file vtkSurfaceLICInterface.h.

## ◆ NoiseTextureSize

int vtkSurfaceLICInterface::NoiseTextureSize
| protected

Definition at line 575 of file vtkSurfaceLICInterface.h.

## ◆ NoiseGrainSize

int vtkSurfaceLICInterface::NoiseGrainSize
| protected

Definition at line 576 of file vtkSurfaceLICInterface.h.

## ◆ MinNoiseValue

double vtkSurfaceLICInterface::MinNoiseValue
| protected

Definition at line 577 of file vtkSurfaceLICInterface.h.

## ◆ MaxNoiseValue

double vtkSurfaceLICInterface::MaxNoiseValue
| protected

Definition at line 578 of file vtkSurfaceLICInterface.h.

## ◆ NumberOfNoiseLevels

int vtkSurfaceLICInterface::NumberOfNoiseLevels
| protected

Definition at line 579 of file vtkSurfaceLICInterface.h.

## ◆ ImpulseNoiseProbability

double vtkSurfaceLICInterface::ImpulseNoiseProbability
| protected

Definition at line 580 of file vtkSurfaceLICInterface.h.

## ◆ ImpulseNoiseBackgroundValue

double vtkSurfaceLICInterface::ImpulseNoiseBackgroundValue
| protected

Definition at line 581 of file vtkSurfaceLICInterface.h.

## ◆ NoiseGeneratorSeed

int vtkSurfaceLICInterface::NoiseGeneratorSeed
| protected

Definition at line 582 of file vtkSurfaceLICInterface.h.

## ◆ AlwaysUpdate

int vtkSurfaceLICInterface::AlwaysUpdate
| protected

Definition at line 584 of file vtkSurfaceLICInterface.h.

## ◆ CompositeStrategy

int vtkSurfaceLICInterface::CompositeStrategy
| protected

Definition at line 585 of file vtkSurfaceLICInterface.h.

## ◆ Internals

vtkSurfaceLICHelper* vtkSurfaceLICInterface::Internals
| protected

Definition at line 587 of file vtkSurfaceLICInterface.h.

The documentation for this class was generated from the following file:

- Rendering/LICOpenGL2/vtkSurfaceLICInterface.h